% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extract.ctStanFit.R
\name{ctExtract}
\alias{ctExtract}
\alias{extract}
\title{Extract samples from a ctStanFit object}
\usage{
ctExtract(
  object,
  subjectMatrices = FALSE,
  cores = 2,
  nsamples = "all",
  subjects = "all"
)
}
\arguments{
\item{object}{ctStanFit object, samples may be from Stan's HMC, or the importance sampling approach of ctsem.}

\item{subjectMatrices}{Calculate subject specific system matrices?}

\item{cores}{Only used if subjectMatrices = TRUE . For faster computation use more cores.}

\item{nsamples}{either 'all' or an integer denoting number of random samples to extract.}

\item{subjects}{either 'all', or an integer vector denoting subjects to extract.}
}
\value{
Array of posterior samples.
}
\description{
Extract samples from a ctStanFit object
}
\examples{
\donttest{
e = ctExtract(ctstantestfit)
}
}
