% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ctsem-package.R
\docType{package}
\name{ctsem-package}
\alias{ctsem}
\alias{ctsem-package}
\title{ctsem}
\description{
ctsem is an R package for continuous time structural equation modelling of panel (N > 1) 
and time series (N = 1) data, using either a frequentist or Bayesian approach, or middle
ground forms like maximum a posteriori. 
 
The general workflow begins by specifying a model using the \code{\link{ctModel}} function, 
in which the \code{type} of model is also specified. Then the model is fit to data using 
\code{\link{ctStanFit}}. The ctFit function which allows for fitting using the OpenMx / SEM form,
as described in the original JSS ctsem paper, can now be found in the ctsemOMX package.  
The omx forms are no longer in 
development and for most purposes, the newer stan based forms are more robust and flexible.
For examples, see  \code{\link{ctStanFit}}. 
For citation info, please run \code{citation('ctsem')} .
}
\references{
https://www.jstatsoft.org/article/view/v077i05

Driver, C. C., & Voelkle, M. C. (2018). Hierarchical Bayesian continuous time dynamic modeling. 
Psychological Methods. Advance online publication.http://dx.doi.org/10.1037/met0000168

Stan Development Team (2018). RStan: the R interface to Stan. R package version 2.17.3. http://mc-stan.org

#' @keywords internal
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/cdriveraus/ctsem}
}

}
\author{
\strong{Maintainer}: Charles Driver \email{charles.driver2@uzh.ch} [copyright holder]

Authors:
\itemize{
  \item Manuel Voelkle [copyright holder]
  \item Han Oud [copyright holder]
}

Other contributors:
\itemize{
  \item Trustees of Columbia University [copyright holder]
}

}
